
class: center, middle

# Exercise 4

  
### Queueing

---

##  Exercise 4 - Goals

- With the configs from exercise 3, now add:
<br><br><br>
- A set of queues, and
<br><br><br>
- Statements to add rules to the queues

---

## Exercise 4 - on Gateway

- Configure the queues
<br><br>

### /etc/pf.conf

```shell
queue rootq on $ext_if bandwidth 20M
    queue main parent rootq bandwidth 20479K min 1M max 20479K qlimit 100
        queue default parent main bandwidth 9600K min 6000K max 18M default
        queue http parent main bandwidth 9600K min 6000K max 18M
        queue smtp parent main bandwidth 9600K min 6000K max 18M
    queue spamd parent rootq bandwidth 1K min 0K max 1K qlimit 300
```

---
## Exercise 4 - on Gateway

- and then apply them to the match statements

### /etc/pf.conf

```shell
match in on egress inet proto tcp to egress port $webports rdr-to $webserver_v4 \
      queue http
match in on egress inet proto tcp to egress port $email rdr-to $emailserver_v4 \
      queue smtp

pass inet6 proto tcp to $webserver_v6 port $webports set queue http
pass inet6 proto tcp to $emailserver_v6 port $email set queue smtp
pass log inet6 proto tcp from $emailserver_v6 to port smtp set queue smtp

```

---


## Exercise 4 - Check

- Check the queues have been effectively created

```shell
 # systat queues

```
<br><br><br>
- or, alternatively

```shell
 # pfctl -vsq

```
---

