class: center, middle

# Network Management with the OpenBSD Packet Filter Toolset



## EuroBSDCon 2019




### Peter Hansteen and Massimiliano Stucchi

---

## whoami (who am I), part Peter:

### Peter Hansteen <peter@bsdly.net> 

- Sysadmin, [OpenBSD](http://www.openbsd.org) user since before the millenium 
	  
- Wrote [The Book of PF](https://www.nostarch.com/pf3), now in its third edition

- Blog at [bsdly.blogspot.com](http://bsdly.blogspot.com) about (lack of) sanity in IT

- Yes, I'll do another book any decade now

---

## whoami (who am I), part Max:

### Massimiliano Stucchi

  - Technical Advisor at The Internet Societyx
    - Here representing myself only

	
  - IPv6 "Enthusiast"

  
  - @stucchimax, https://stucchi.ch


---

## Introduce yourself

- A quick introduction about yourself:

  - Your name

  - Your favourite BSD

  - Your experience with networking

  - Your experience with PF

  - Your goal(s)

???

This introduction serves for us to understand the level of the room, and decide on how to better suit
the tutorial.

Getting an idea of the level makes it so that we might quickly go through the basics, and focus on something
more advanced, rather than spend time on something that everybody knows already.

---

## Agenda

1. PF Basics
2. Exercise: Host configuration
3. NAT and Redirects
4. Exercise: Setup a gateway
5. Hosting Services
6. Exercise: Hosting Services, redirects
7. Traffic Shaping
8. Exercise: Setting up queueing
9. Tips
10. Troubleshooting
11. Exercise: NAT64
12. End

---
